﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Security;
using ExcelExport.Models;
using Infragistics.Web.Mvc;
using Infragistics.Documents.Excel;

namespace ExcelExport.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            return View(SimpleItem.GetItemsList().AsQueryable());
        }

        [HttpPost]
        public void Export()
        {
            List<SimpleItem> items = SimpleItem.GetItemsList();
            Workbook workbook = new Workbook(WorkbookFormat.Excel97To2003);
            Worksheet sheet = workbook.Worksheets.Add("Sheet 1");
            int i = 1;
            foreach (SimpleItem item in items)
            {
                sheet.Rows[i].Cells[0].Value = item.Text1;
                sheet.Rows[i].Cells[1].Value = item.Text2;
                i++;
            }
            Save(workbook);
        }

        private void Save(Workbook document)
        {
            string fileName = "Document1.xls";
            Response.Clear();
            Response.AppendHeader("content-disposition", "attachment; filename=" + fileName);
            Response.ContentType = "application/octet-stream";
            document.SetCurrentFormat(WorkbookFormat.Excel97To2003);
            document.Save(Response.OutputStream);
            Response.End();
        }

        public ActionResult Import() {
            Workbook wb = Workbook.Load(Server.MapPath("~/Content/Document1.xls"));
            Worksheet sheet = wb.Worksheets[0];
            List<SimpleItem> data = new List<SimpleItem>();

            foreach (WorksheetRow row in sheet.Rows)
            {
                if (row.Cells[0].Value != null && row.Cells[1].Value != null)
                {
                    SimpleItem item = new SimpleItem 
                    {
                        Text1 = row.Cells[0].Value.ToString(),
                        Text2 = row.Cells[1].Value.ToString()
                    };

                    data.Add(item);
                }

            }
            return View(data.AsQueryable());
        }
    }
}
